package com.sun.xml.internal.ws.developer;

import javax.xml.ws.WebServiceException;
import java.net.CookieHandler;
import java.lang.reflect.Constructor;
import javax.xml.ws.WebServiceFeature;

public final class HttpConfigFeature extends WebServiceFeature
{
    public static final String ID = "http://jax-ws.java.net/features/http-config";
    private static final Constructor cookieManagerConstructor;
    private static final Object cookiePolicy;
    private final CookieHandler cookieJar;
    
    public HttpConfigFeature() {
        this(getInternalCookieHandler());
    }
    
    public HttpConfigFeature(CookieHandler cookieJar) {
        this.enabled = true;
        this.cookieJar = cookieJar;
    }
    
    private static CookieHandler getInternalCookieHandler() {
        try {
            return (CookieHandler)HttpConfigFeature.cookieManagerConstructor.newInstance(new Object[] { null, HttpConfigFeature.cookiePolicy });
        }
        catch (Exception e) {
            throw new WebServiceException(e);
        }
    }
    
    public String getID() {
        return "http://jax-ws.java.net/features/http-config";
    }
    
    public CookieHandler getCookieHandler() {
        return this.cookieJar;
    }
    
    static {
        Constructor<Object> tempConstructor;
        Object tempPolicy;
        try {
            Class<Object> policyClass = Class.forName("java.net.CookiePolicy");
            Class<Object> storeClass = Class.forName("java.net.CookieStore");
            tempConstructor = Class.forName("java.net.CookieManager").getConstructor(new Class[] { storeClass, policyClass });
            tempPolicy = policyClass.getField("ACCEPT_ALL").get(null);
        }
        catch (Exception e) {
            try {
                Class<Object> policyClass2 = Class.forName("com.sun.xml.internal.ws.transport.http.client.CookiePolicy");
                Class<Object> storeClass2 = Class.forName("com.sun.xml.internal.ws.transport.http.client.CookieStore");
                tempConstructor = Class.forName("com.sun.xml.internal.ws.transport.http.client.CookieManager").getConstructor(new Class[] { storeClass2, policyClass2 });
                tempPolicy = policyClass2.getField("ACCEPT_ALL").get(null);
            }
            catch (Exception ce) {
                throw new WebServiceException(ce);
            }
        }
        cookieManagerConstructor = tempConstructor;
        cookiePolicy = tempPolicy;
    }
}
